/*
 * $Id: poseidon.c,v 1.11 2008/06/29 16:32:46 platon42 Exp $
 *
 * Poseidon prefs loader  2003 Jacek Piszczek. NOT part of AROS!
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <proto/iffparse.h>
#define DEBUG 0
#include <aros/debug.h>

#define D(x) ;

#if 0
void SetupPoseidon(APTR filemem,ULONG size)
{
	struct Library *PsdBase = NULL;

	/* This Delay() call should not be needed, however it appears that if
	 * it's missing the system will fail to boot most of the time (bootpic
	 * gets closed, but no Ambient screen appear). Probably some race
	 * condition somewhere... :( - Piru
	 */

	//D(dprintf("SetupPoseidon: Delay 2...\n"));
	//#warning "Someone figure out why this Delay() is needed!"
	//Delay(5);
	//D(dprintf("SetupPoseidon: Delay 2 done, continue..., Task 0x%8.8lx\n", FindTask(NULL) ));

	if ((PsdBase = OpenLibrary("poseidon.library", 3)))
	{
    	D(dprintf("%s: ReadCfg & ParseCfg\n", __func__));
    	psdReadCfg(NULL,filemem);
	    psdParseCfg();

		D(dprintf("SetupPoseidon: Close poseidon.library\n"))
		CloseLibrary(PsdBase);
	}

	FreeMem(filemem,size);

	D(dprintf("SetupPoseidon: Task end\n"));
}
#endif

#define POSNAME "IPrefs Poseidon Thingie"

void LoadPoseidonPrefs(char *filename)
{
	BPTR	MyFile;
	ULONG size = 0;
	ULONG *filemem = 0;
	struct FileInfoBlock *fib;
	LONG res;

	D(bug("%s: <%s>\n",__func__,filename));

	if ((MyFile = Open(filename,MODE_OLDFILE)))
	{
		if ((fib = AllocDosObject(DOS_FIB,0)))
		{
			res = ExamineFH(MyFile,fib);

			size = fib->fib_Size;

			FreeDosObject(DOS_FIB,fib);

			if (res && size)
			{
				if ((filemem = AllocMem(size,MEMF_PUBLIC)))
				{
					if (Read(MyFile,filemem,size) == size)
					{
#if 1
                    	struct Library *PsdBase;
                    	if ((PsdBase = OpenLibrary("poseidon.library", 4)))
                    	{
                        	D(dprintf("%s: ReadCfg & ParseCfg\n", __func__));
                        	psdReadCfg(NULL, filemem);
                    	    psdParseCfg();

                    		D(dprintf("SetupPoseidon: Close poseidon.library\n"))
                    		CloseLibrary(PsdBase);
                    	}
#else
						if ((CreateNewProcTags(NP_Name,(ULONG)POSNAME,
									   NP_CodeType,CODETYPE_PPC,
									   NP_Entry,(ULONG)SetupPoseidon,
									   NP_WindowPtr,(ULONG)-1,
									   NP_PPC_Arg1,(ULONG)filemem,
									   NP_PPC_Arg2,(ULONG)size,
									   TAG_DONE)))
						{
							filemem = NULL; //will be disposed by our process
						}
#endif
					}
					if (filemem)
					{
						D(bug("%s: free filemem 0x%lx size %ld\n",__func__,filemem,size));
						FreeMem(filemem,size);
					}
				}
				else
				{
					D(bug("%s: can't alloc filebuffer, %ld bytes\n",__func__,size));
				}
			}
			else
			{
				D(bug("%s: examine <%s> failed\n",__func__,filename));
			}
		}
		else
		{
			D(bug("%s: can't create fib\n",__func__));
		}
		Close(MyFile);
	}
	else
	{
		D(bug("%s: no <%s>\n",__func__,filename));
	}
}

